<?php

namespace MJ\LoginAsUser;

use XF\Db\Schema\Alter;
use XF\Db\Schema\Create;

class Setup extends \XF\AddOn\AbstractSetup
{
	use \XF\AddOn\StepRunnerInstallTrait;
	use \XF\AddOn\StepRunnerUpgradeTrait;
	use \XF\AddOn\StepRunnerUninstallTrait;

	// ################################ INSTALLATION ################################

	public function installStep1()
	{
		$sm = $this->schemaManager();

		foreach ($this->getTables() as $tableName => $closure)
		{
			$sm->createTable($tableName, $closure);
		}
	}

	// ############################################ UNINSTALL #########################

	public function uninstallStep1()
	{
		$sm = $this->schemaManager();

		foreach (array_keys($this->getTables()) as $tableName)
		{
			$sm->dropTable($tableName);
		}
	}

	// ############################# TABLE / DATA DEFINITIONS ##############################

	protected function getTables()
	{
		$tables = [];

		$tables['xf_mjlau_login_log'] = function(Create $table)
		{
			$table->addColumn('log_id', 'int')->autoIncrement();
			$table->addColumn('user_id', 'int');
			$table->addColumn('login_user_id', 'int');
			$table->addColumn('reason', 'text');
			$table->addColumn('ip_address', 'varbinary', 16);
			$table->addColumn('login_date', 'int')->setDefault(0);
		};

		return $tables;
	}
}
